using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.Video;
using System.Text;
using System.Linq;
using UnityEngine.UI;
using System.IO;
using UnityEngine.Experimental.Audio;
using UnityEngine.Experimental.Video;
using Unity.Collections;
using System.Timers;
using UnityEngine.EventSystems;



namespace VamSander {


public class MyVirtualHomeTheater : MVRScript
{

	string[] speakers = new string[] {"FL","FR","C","LFE","BSL","BSR","SL","SR"};
	
	GameObject playerObject = new GameObject();
	GameObject playerObjectRightEye = new GameObject();
	GameObject GoCameraRight;
    AudioSampleProvider provider;
	VideoPlayer player;
	VideoPlayer playerVideo;
	Renderer renderer;
	Renderer rendererRightEye;
    GameObject audioCObj = new GameObject();
	AudioSource[] audiosources = new AudioSource[8];
	GetChannel[] getchannels = new GetChannel[8];
	int[] channels = new int[8];
	string[] spheres = new string[] {"VirtualHomeTheater/SphereFL","VirtualHomeTheater/SphereFR","VirtualHomeTheater/SphereC","VirtualHomeTheater/SphereLFE","VirtualHomeTheater/SphereBSL","VirtualHomeTheater/SphereBSR","VirtualHomeTheater/SphereSL","VirtualHomeTheater/SphereSR"};
	int channelcount;
	Timer timer = new Timer();
	Timer timer2 = new Timer();	
	bool freezed = false;
	int TextFileshiftindex = 0;
	int originalMask = 0;
	int originalLayer = 0;


	Atom myAtom;
	Transform  TimeSliderTransform;
	Transform  OffsetSliderTransform;	
	DraggingSlider DragTimeSlider;
	DraggingSlider DragOffsetSlider;
	Transform MovieTimerTransform;	
	Transform TextFileTransform;	
	Transform FillTransform;
	Transform StereoSBSToggleTransform;
	Transform StereoOUToggleTransform;
	Transform ToggleInterfaceTransform20;
	Transform ToggleInterfaceTransform51;
	Transform ToggleInterfaceTransform71;
	Transform[] SpheresTransforms = new Transform[8];
	Draggable DraggableInterface;


	JSONStorableString jsonVideoFile;
	JSONStorableAction jsonVideoPlay;
	JSONStorableBool jsonVideoPaused;
	JSONStorableAction jsonVideoStop;
	JSONStorableFloat jsonTimeScrubFloat;
	JSONStorableFloat jsonAudioOffsetFloat;
	JSONStorableFloat jsonScreenSizeFloat;
	JSONStorableBool jsonVideo3DSBS;
	JSONStorableBool jsonVideo3DOU;

	JSONStorableFloat jsonVolumeFLFloat;	
	JSONStorableFloat jsonVolumeFRFloat;
	JSONStorableFloat jsonVolumeCFloat;
	JSONStorableFloat jsonVolumeLFEFloat;
	JSONStorableFloat jsonVolumeBSLFloat;
	JSONStorableFloat jsonVolumeBSRFloat;		
	JSONStorableFloat jsonVolumeSLFloat;
	JSONStorableFloat jsonVolumeSRFloat;	
		

	JSONStorableFloat jsonChannelFLFloat;	
	JSONStorableFloat jsonChannelFRFloat;
	JSONStorableFloat jsonChannelCFloat;
	JSONStorableFloat jsonChannelLFEFloat;	
	JSONStorableFloat jsonChannelBSLFloat;
	JSONStorableFloat jsonChannelBSRFloat;
	JSONStorableFloat jsonChannelSLFloat;
	JSONStorableFloat jsonChannelSRFloat;	


	JSONStorableString jsonSwapChannel;

	JSONStorableAction jsonToggleInterface;			

	public override void Init() {
	try {
	// JSON storage

	jsonVideoFile = new JSONStorableString("Video File", "", BrowseButtonCallback);
	RegisterString(jsonVideoFile);

	jsonVideoPlay = new JSONStorableAction("Play_Pause", PlayCallback);
	RegisterAction(jsonVideoPlay);

	jsonVideoPaused = new JSONStorableBool("Video Paused", false);
	RegisterBool(jsonVideoPaused);

	jsonVideoStop = new JSONStorableAction("Stop", StopCallback);
	RegisterAction(jsonVideoStop);

	jsonTimeScrubFloat = new JSONStorableFloat("Time Scrub", 0f, 0f, 1f, true);
	RegisterFloat(jsonTimeScrubFloat);

	jsonAudioOffsetFloat = new JSONStorableFloat("Audio Offset", 0f, -1f, 1f, true);
	RegisterFloat(jsonAudioOffsetFloat);

	jsonScreenSizeFloat = new JSONStorableFloat("Screen Size", 0f, ScreenSizeCallback, -3f, 3f, true);
	RegisterFloat(jsonScreenSizeFloat);

	jsonVideo3DSBS = new JSONStorableBool("Video 3D SBS", false, StereoSBScallback);
	RegisterBool(jsonVideo3DSBS);

	jsonVideo3DOU = new JSONStorableBool("Video 3D OU", false, StereoOUcallback);
	RegisterBool(jsonVideo3DOU);

	
	jsonVolumeFLFloat = new JSONStorableFloat("VolumeFL", 1f, VolumeFLCallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeFLFloat);
	
	jsonVolumeFRFloat = new JSONStorableFloat("VolumeFR", 1f, VolumeFRCallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeFRFloat);

	jsonVolumeCFloat = new JSONStorableFloat("VolumeC", 1f, VolumeCCallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeCFloat);	

	jsonVolumeLFEFloat = new JSONStorableFloat("VolumeLFE", 1f, VolumeLFECallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeLFEFloat);		

	jsonVolumeBSLFloat = new JSONStorableFloat("VolumeBSL", 1f, VolumeBSLCallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeBSLFloat);
	
	jsonVolumeBSRFloat = new JSONStorableFloat("VolumeBSR", 1f, VolumeBSRCallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeBSRFloat);	

	jsonVolumeSLFloat = new JSONStorableFloat("VolumeSL", 1f, VolumeSLCallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeSLFloat);
	
	jsonVolumeSRFloat = new JSONStorableFloat("VolumeSR", 1f, VolumeSRCallback, 0f, 1f, true);
	RegisterFloat(jsonVolumeSRFloat);


	jsonChannelFLFloat = new JSONStorableFloat("ChannelFL", 0f, 0f, 7f, true);
	RegisterFloat(jsonChannelFLFloat);
	
	jsonChannelFRFloat = new JSONStorableFloat("ChannelFR", 1f, 0f, 7f, true);
	RegisterFloat(jsonChannelFRFloat);

	jsonChannelCFloat = new JSONStorableFloat("ChannelC", 2f, 0f, 7f, true);
	RegisterFloat(jsonChannelCFloat);

	jsonChannelLFEFloat = new JSONStorableFloat("ChannelLFE", 3f, 0f, 7f, true);
	RegisterFloat(jsonChannelLFEFloat);

	jsonChannelBSLFloat = new JSONStorableFloat("ChannelBSL", 4f, 0f, 7f, true);
	RegisterFloat(jsonChannelBSLFloat);
	
	jsonChannelBSRFloat = new JSONStorableFloat("ChannelBSR", 5f, 0f, 7f, true);
	RegisterFloat(jsonChannelBSRFloat);	

	jsonChannelSLFloat = new JSONStorableFloat("ChannelSL", 6f, 0f, 7f, true);
	RegisterFloat(jsonChannelSLFloat);
	
	jsonChannelSRFloat = new JSONStorableFloat("ChannelSR", 7f, 0f, 7f, true);
	RegisterFloat(jsonChannelSRFloat);	


	jsonSwapChannel = new JSONStorableString("Swap Channel", "", SwapChannelCallBack);
	RegisterString(jsonSwapChannel);

	jsonToggleInterface = new JSONStorableAction("Toggle Interface", ToggleInterfaceCallback);
	RegisterAction(jsonToggleInterface);

	}
	catch (Exception e) {
		SuperController.LogError("Exception caught: " + e);
	}
	}




	// UI callbacks

	void BrowseButtonCallback(string js)
	{
		if (jsonVideoFile.val=="dummystring")
		{	
			SuperController.singleton.NormalizeMediaPath("/");
			SuperController.singleton.ShowMainHUD(false, false);
			jsonVideoFile.val = player.url;			
			SuperController.singleton.GetMediaPathDialog(FileChosenCallback);

		}		
	}

	void FileChosenCallback(string path)
	{ 	
		SuperController.singleton.ToggleMainHUD();

		if (path != "") //Path = "" --> GetMediaPathDialog has been canceled and no new file chosen
		{
			jsonVideoFile.val = path;
			SuperController.LogMessage(jsonVideoFile.val);
			playerVideo.url = jsonVideoFile.val;
			player.url = jsonVideoFile.val;
			jsonVideoPaused.val = false;
			TextFileshiftindex = 0;
			TimeSliderTransform.gameObject.GetComponent<UnityEngine.UI.Slider>().value = 0;
			OffsetSliderTransform.gameObject.GetComponent<UnityEngine.UI.Slider>().value = 0.5f;
			SwapChannelCallBack("1,1");
			SwapChannelCallBack("2,2");
			SwapChannelCallBack("3,3");
			SwapChannelCallBack("4,4");
			SwapChannelCallBack("5,5");
			SwapChannelCallBack("6,6");
			SwapChannelCallBack("7,7");
		
			ResetPlayer();
		}
	}

	void PlayCallback()
	{
		if (playerVideo.isPlaying)
			{	
				playerVideo.Pause();
				player.Pause();

				for (int i=0; i<8; i++)
				{
					if (audiosources[i] != null)
			 			audiosources[i].Stop();
				}
				jsonVideoPaused.val = true;

			}
		else
			{if (player.isPrepared)
					{	
						playerVideo.Play();
						player.Play();

						for (int i=0; i<8; i++)
						{
							if (audiosources[i] != null)
								audiosources[i].Play();
						}
						jsonVideoPaused.val = false;
					}
			 else
			 	if (player.url != "")
					{			 			
						ResetPlayer();	
					}
			}		
	}

	void StopCallback()
	{
		playerVideo.Stop();
		player.Stop();

		for (int i=0; i<8; i++)
		{
			if (audiosources[i] != null)
				audiosources[i].Stop();
		}
		jsonVideoPaused.val = false;
		TimeSliderTransform.gameObject.GetComponent<UnityEngine.UI.Slider>().value = 0;
		OffsetSliderTransform.gameObject.GetComponent<UnityEngine.UI.Slider>().value = 0.5f;
		MovieTimerTransform.gameObject.GetComponent<UnityEngine.UI.Text>().text = "0:00:00";
		renderer.material.mainTexture =  null;
		rendererRightEye.material.mainTexture =  null;
	}
	

	void ScreenSizeCallback(float js)
	{	
		if (js >= 0f)
			js = js + 1f;
		else
			js = -1f / (js - 1f);
		playerObject.transform.localScale = new Vector3(js, js, js);
        playerObjectRightEye.transform.localScale = new Vector3(js, js, js);
	}

	void VolumeFLCallback(float js)
	{	
			if (audiosources[0] != null)
				audiosources[0].volume = js;
	}

	void VolumeFRCallback(float js)
	{	
			if (audiosources[1] != null)
				audiosources[1].volume = js;
	}

	void VolumeCCallback(float js)
	{	
			if (audiosources[2] != null)
				audiosources[2].volume = js;
	}

	void VolumeLFECallback(float js)
	{	
			if (audiosources[3] != null)
				audiosources[3].volume = js;
	}

	void VolumeBSLCallback(float js)
	{	
			if (audiosources[4] != null)
				audiosources[4].volume = js;
	}

	void VolumeBSRCallback(float js)
	{	
			if (audiosources[5] != null)
				audiosources[5].volume = js;
	}

	void VolumeSLCallback(float js)
	{	
			if (audiosources[6] != null)
				audiosources[6].volume = js;
	}

	void VolumeSRCallback(float js)
	{	
			if (audiosources[7] != null)
				audiosources[7].volume = js;
	}


	void SwapChannelCallBack(string js)
	{	
		Atom myAtom;
		Transform ButtonTrasform;
		int speaker = Int16.Parse(js.Substring(0,1)) - 1;
		int newchannel = Int16.Parse(js.Substring(2,1)) - 1 ;

		if (jsonVideoFile.val != "")
		{
			if (channels[speaker] != newchannel)
			{
				int oldchannel = channels[speaker];				
				int j = 0;
				while (channels[j] != newchannel)
					j++;

				channels[j] = oldchannel;
				channels[speaker] = newchannel;

				myAtom = SuperController.singleton.GetAtomByUid("VirtualHomeTheater");

				ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButton" + (speakers[j]) + (newchannel+1).ToString());
				ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
				ButtonTrasform.gameObject.GetComponent<Text>().color = Color.black;

				ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButton" + (speakers[speaker]) + (oldchannel+1).ToString());
				ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
				ButtonTrasform.gameObject.GetComponent<Text>().color = Color.black;

				ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButton" + (speakers[j]) + (oldchannel+1).ToString());
				ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
				ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

				ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButton" + (speakers[speaker]) + (newchannel+1).ToString());
				ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
				ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;


				jsonChannelFLFloat.val = (float) channels[0];	
				jsonChannelFRFloat.val = (float) channels[1];
				jsonChannelCFloat.val = (float) channels[2];
				jsonChannelLFEFloat.val = (float) channels[3];
				jsonChannelBSLFloat.val = (float) channels[4];
				jsonChannelBSRFloat.val = (float) channels[5];	
				jsonChannelSLFloat.val = (float) channels[6];
				jsonChannelSRFloat.val = (float) channels[7];

				if  (player.isPrepared)
				{
					playerVideo.Stop();
					player.Stop();

					ResetPlayer();	
				}
			}
		}
	}

	void ToggleInterfaceCallback()
	{
		Atom DragButtonAtom = SuperController.singleton.GetAtomByUid("VirtualHomeTheater/UIButtonDraggableInterface");
		Atom ToggleButtonAtom = SuperController.singleton.GetAtomByUid("VirtualHomeTheater/UIButtonInterfaceToggle");

		JSONStorableFloat jsonDragxSize = DragButtonAtom.GetStorableByID("Canvas").GetFloatJSONParam("xSize");
		JSONStorableFloat jsonDragySize = DragButtonAtom.GetStorableByID("Canvas").GetFloatJSONParam("ySize");	
		JSONStorableFloat jsonTogglexSize = ToggleButtonAtom.GetStorableByID("Canvas").GetFloatJSONParam("xSize");
		JSONStorableFloat jsonToggleySize = ToggleButtonAtom.GetStorableByID("Canvas").GetFloatJSONParam("ySize");
		JSONStorableString jsonDragText = DragButtonAtom.GetStorableByID("Text").GetStringJSONParam("text");
		JSONStorableString jsonToggleText = ToggleButtonAtom.GetStorableByID("Text").GetStringJSONParam("text");

		FreeControllerV3 contr = SuperController.singleton.GetAtomByUid("VirtualHomeTheater/UIButtonInterfaceToggle").GetStorableByID("control") as FreeControllerV3;		
		Vector3 TogglePos = contr.gameObject.transform.localPosition;

		if (ToggleInterfaceTransform20.gameObject.activeInHierarchy)
		{
			ToggleInterfaceTransform20.gameObject.SetActive(false);
			ToggleInterfaceTransform51.gameObject.SetActive(false);				
			ToggleInterfaceTransform71.gameObject.SetActive(false);
			jsonDragText.val = " ";
			jsonToggleText.val = " ";
			jsonTogglexSize.val = 200.0f;
			jsonToggleySize.val = 200.0f;
			jsonDragxSize.val = 200.0f;
			jsonDragySize.val = 200.0f;
			TogglePos.y = TogglePos.y - 0.06f;
			contr.gameObject.transform.localPosition = TogglePos;			
			return;
		}

		if  (player.isPrepared || playerVideo.isPlaying || (jsonVideoFile.val != ""))
		{
			FillTransform.gameObject.GetComponent<CanvasRenderer>().SetColor(Color.red);
			switch(channelcount) 
			{
				case 8:
					ToggleInterfaceTransform20.gameObject.SetActive(true);
					ToggleInterfaceTransform51.gameObject.SetActive(true);				
					ToggleInterfaceTransform71.gameObject.SetActive(true);
					jsonTogglexSize.val = 100.0f;
					jsonToggleySize.val = 100.0f;
					jsonDragxSize.val = 100.0f;
					jsonDragySize.val = 100.0f;	
					TogglePos.y = TogglePos.y + 0.06f;
					contr.gameObject.transform.localPosition = TogglePos;
					return;
					break;
				case 6:
					ToggleInterfaceTransform20.gameObject.SetActive(true);				
					ToggleInterfaceTransform51.gameObject.SetActive(true);	
					ToggleInterfaceTransform71.gameObject.SetActive(false);
					jsonTogglexSize.val = 100.0f;
					jsonToggleySize.val = 100.0f;
					jsonDragxSize.val = 100.0f;
					jsonDragySize.val = 100.0f;
					TogglePos.y = TogglePos.y + 0.06f;
					contr.gameObject.transform.localPosition = TogglePos;	
					return;
					break;
				default:
					ToggleInterfaceTransform51.gameObject.SetActive(false);				
					ToggleInterfaceTransform71.gameObject.SetActive(false);
					ToggleInterfaceTransform20.gameObject.SetActive(true);
					jsonTogglexSize.val = 100.0f;
					jsonToggleySize.val = 100.0f;
					jsonDragxSize.val = 100.0f;
					jsonDragySize.val = 100.0f;		
					TogglePos.y = TogglePos.y + 0.06f;
					contr.gameObject.transform.localPosition = TogglePos;
					return;
					break;
			}	

		}

		FillTransform.gameObject.GetComponent<CanvasRenderer>().SetColor(Color.red);		
		ToggleInterfaceTransform20.gameObject.SetActive(true);
		ToggleInterfaceTransform51.gameObject.SetActive(true);				
		ToggleInterfaceTransform71.gameObject.SetActive(true);
		jsonTogglexSize.val = 100.0f;
		jsonToggleySize.val = 100.0f;
		jsonDragxSize.val = 100.0f;
		jsonDragySize.val = 100.0f;
		TogglePos.y = TogglePos.y + 0.06f;
		contr.gameObject.transform.localPosition = TogglePos;
	}

	void StereoSBScallback(bool js)
	{	
		if (jsonVideo3DOU.val && jsonVideo3DSBS.val)
		{
			if (StereoOUToggleTransform.gameObject.GetComponent<UnityEngine.UI.Toggle>() == null)
				SuperController.LogMessage("No Toggle Component");
			else
				SuperController.LogMessage("Toggle Component OK");
				StereoOUToggleTransform.gameObject.GetComponent<UnityEngine.UI.Toggle>().isOn = false;
		}

		if  (player.isPrepared || playerVideo.isPlaying)
		{
			playerVideo.Stop();
			player.Stop();

			for (int i=0; i<8 ; i++)
			{
				if (audiosources[i] != null)
				{		
					Destroy(audiosources[i].clip);
					Destroy(audiosources[i]);
				}		
				if (getchannels[i] != null)
					Destroy(getchannels[i]);
			}					
			if (jsonVideoFile.val != "")
			{						
				player.Prepare();
				SuperController.LogMessage("Prepare");
			}
		}
	}

	void StereoOUcallback (bool js)
	{
		if (jsonVideo3DSBS.val && jsonVideo3DOU.val)
		{
			if (StereoSBSToggleTransform.gameObject.GetComponent<UnityEngine.UI.Toggle>() == null)
				SuperController.LogMessage("No Toggle Component");
			else
				SuperController.LogMessage("Toggle Component OK");
				StereoSBSToggleTransform.gameObject.GetComponent<UnityEngine.UI.Toggle>().isOn = false;
		}

		if  (player.isPrepared || playerVideo.isPlaying)
		{
			playerVideo.Stop();
			player.Stop();

			for (int i=0; i<8 ; i++)
			{
				if (audiosources[i] != null)
				{		
					Destroy(audiosources[i].clip);
					Destroy(audiosources[i]);
				}		
				if (getchannels[i] != null)
					Destroy(getchannels[i]);
			}					
			if (jsonVideoFile.val != "")
			{						
				player.Prepare();
				SuperController.LogMessage("Prepare");
			}
		}
	}


	//End UI callbacks


	void Update()
	{
		if (SuperController.singleton.freezeAnimation)
		{
			if (playerVideo.isPlaying)
			{	
				playerVideo.Pause();
				player.Pause();
				for (int i=0; i<8; i++)
				{
					if (audiosources[i] != null)
						audiosources[i].Stop();
				}
				jsonVideoPaused.val = true;
				freezed = true;
			}
		}
		else
		{
			if (freezed)
			{	
				playerVideo.Play();
				player.Play();
				for (int i=0; i<8; i++)
				{
					if (audiosources[i] != null)
						audiosources[i].Play();
				}
				jsonVideoPaused.val = false;
				freezed = false;
			}
		}





		if  (player.isPrepared || playerVideo.isPlaying)
		{
			renderer.material.mainTexture =  playerVideo.texture;
            if ((jsonVideo3DSBS.val || jsonVideo3DOU.val) && (SuperController.singleton.isOVR || SuperController.singleton.isOpenVR))
                rendererRightEye.material.mainTexture = playerVideo.texture;
		}





		if  (player.isPrepared || playerVideo.isPlaying)
		{
			double MovieTimeSecs = (double) (TimeSliderTransform.gameObject.GetComponent<UnityEngine.UI.Slider>().value * (((double)playerVideo.frameCount) / (double) playerVideo.frameRate));
			TimeSpan MovieTimeSpan = TimeSpan.FromSeconds(MovieTimeSecs);
			MovieTimerTransform.gameObject.GetComponent<UnityEngine.UI.Text>().text = string.Format("{0:D1}:{1:D2}:{2:D2}", MovieTimeSpan.Hours, MovieTimeSpan.Minutes, MovieTimeSpan.Seconds);
		}		

		if (!DragTimeSlider.SliderMouseOver && (playerVideo.isPlaying) && playerVideo.frame > 20)
 			TimeSliderTransform.gameObject.GetComponent<UnityEngine.UI.Slider>().value = (float)((float)playerVideo.frame / (float)playerVideo.frameCount); 

		if (DragTimeSlider.SliderMousePressed)
			{
				if (playerVideo.isPlaying)
				{	
					playerVideo.Pause();
					player.Pause();

					for (int i=0; i<8; i++)
					{
						if (audiosources[i] != null)
							audiosources[i].Stop();
					}
				} 
				DragTimeSlider.SliderMousePressed = false;
			} 


		if ( DragTimeSlider.SliderMouseReleased)
		{
			if  (player.isPrepared)
			{
				playerVideo.Stop();
				player.Stop();

				for (int i=0; i<8 ; i++)
				{
					if (audiosources[i] != null)
					{		
						Destroy(audiosources[i].clip);
						Destroy(audiosources[i]);
					}		
					if (getchannels[i] != null)
						Destroy(getchannels[i]);
				}
				if (jsonVideoFile.val != "")
				{						
					player.Prepare();
					SuperController.LogMessage("Prepare");
				}		
			}		
			DragTimeSlider.SliderMouseReleased = false;
		}



		if (DragOffsetSlider.SliderMousePressed) 
			{	
				if (playerVideo.isPlaying)
				{
					playerVideo.Pause();
					player.Pause();

					for (int i=0; i<8; i++)
					{
						if (audiosources[i] != null)
							audiosources[i].Stop();
					}
				} 
				DragOffsetSlider.SliderMousePressed = false;
			} 


		if ( DragOffsetSlider.SliderMouseReleased)
		{
			if  (player.isPrepared)
			{
				playerVideo.Stop();
				player.Stop();

				for (int i=0; i<8 ; i++)
				{
					if (audiosources[i] != null)
					{		
						Destroy(audiosources[i].clip);
						Destroy(audiosources[i]);
					}		
					if (getchannels[i] != null)
						Destroy(getchannels[i]);
				}					
				if (jsonVideoFile.val != "")
				{						
					player.Prepare();
					SuperController.LogMessage("Prepare");
				}
			}
			DragOffsetSlider.SliderMouseReleased = false;
		}


	}


	void OnDestroy()
	{
		GameObject go = GameObject.Find("MyRightEyeCam");
		if (go != null)
		{
			CameraTarget.centerTarget.targetCamera.cullingMask = originalMask;
			CameraTarget.centerTarget.targetCamera.stereoTargetEye = StereoTargetEyeMask.Both;
			Destroy(go);
		}
	}


    void Start()
    {
            SuperController.LogMessage("START");

			myAtom = SuperController.singleton.GetAtomByUid("VirtualHomeTheater");


			Transform DraggabeTransform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonDraggableInterface");
			DraggabeTransform = getObjectRoot( DraggabeTransform, "Button" );
			FreeControllerV3 contr = SuperController.singleton.GetAtomByUid("VirtualHomeTheater/UIButtonDraggableInterface").GetStorableByID("control") as FreeControllerV3;
			DraggableInterface = DraggabeTransform.gameObject.AddComponent<Draggable>();
			DraggableInterface.controllerTransform = contr.transform;


			TimeSliderTransform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UISliderVideoScrub");
			TimeSliderTransform = getObjectRoot( TimeSliderTransform, "Slider" );
    		if ( TimeSliderTransform == null )
			{
    			SuperController.LogMessage("NOT FOUND");
    		}
			else 
			{
    			SuperController.LogMessage("FOUND" + " " + TimeSliderTransform.name);
    		}
			DragTimeSlider = TimeSliderTransform.gameObject.AddComponent<DraggingSlider>();



			FillTransform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UISliderVideoScrub");
			FillTransform = getObjectRoot( FillTransform, "Fill" );
			FillTransform.gameObject.GetComponent<CanvasRenderer>().SetColor(Color.red);


			OffsetSliderTransform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UISliderAudioOffset");
			OffsetSliderTransform = getObjectRoot( OffsetSliderTransform, "Slider" );
    		if ( OffsetSliderTransform == null )
			{
    			SuperController.LogMessage("NOT FOUND");
    		}
			else 
			{
    			SuperController.LogMessage("FOUND" + " " + OffsetSliderTransform.name);
    		}
			DragOffsetSlider = OffsetSliderTransform.gameObject.AddComponent<DraggingSlider>();


			MovieTimerTransform = getObjectRoot2(myAtom.reParentObject,"VirtualHomeTheater/TextMovieTimer");
			MovieTimerTransform = getObjectRoot( MovieTimerTransform, "Text" );

			
			TextFileTransform = getObjectRoot2( myAtom.reParentObject, "VirtualHomeTheater/TextFile" );
			TextFileTransform = getObjectRoot( TextFileTransform, "Text" );
			TextFileTransform.gameObject.GetComponent<UnityEngine.UI.Text>().horizontalOverflow = HorizontalWrapMode.Overflow;
			TextFileTransform.gameObject.GetComponent<UnityEngine.UI.Text>().text = "Please open a file";	


			StereoSBSToggleTransform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIToggle3DSBS");
			StereoSBSToggleTransform = getObjectRoot( StereoSBSToggleTransform, "Toggle" );


			StereoOUToggleTransform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIToggle3DOU");
			StereoOUToggleTransform = getObjectRoot( StereoOUToggleTransform, "Toggle" );


			ToggleInterfaceTransform20 = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/TextInterfaceParent20");
			ToggleInterfaceTransform51 = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/TextInterfaceParent51");
			ToggleInterfaceTransform71 = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/TextInterfaceParent71");

			for (int i=0; i<8; i++)
				SpheresTransforms[i] = getObjectRoot2(myAtom.reParentObject, spheres[i]);

			for (int i=0; i<8; i++)
				channels[i] = i;


			InvokeRepeating("ShiftMovieTitle", 0.01f, 0.3f);


            PrimitiveType shape = PrimitiveType.Plane;

			Atom screenAtom = SuperController.singleton.GetAtomByUid("VirtualHomeTheater/EmptyScreen");
			FreeControllerV3 controller = screenAtom.GetStorableByID("control") as FreeControllerV3;
			if (controller == null)
			{
				SuperController.LogMessage("No controller found");
				return;
			}
			GameObject screenroot = controller.gameObject;

			playerObject = GameObject.CreatePrimitive(shape);
			playerObjectRightEye = GameObject.CreatePrimitive(shape);

			GameObject DummyVideoObject = new GameObject();

            playerObject.transform.SetParent(screenroot.transform, false);
			playerObjectRightEye.transform.SetParent(screenroot.transform, false);

			DummyVideoObject.transform.SetParent(screenroot.transform, false);
			
			// quads are created in the x,y plane, the -ve z side is visible
			// planes are created as 10x10 quads (11x11 verts) in the x,z plane, the faces are wound so +ve y is visible
			if (shape == PrimitiveType.Plane)
			{
				SwapZY(playerObject); // we physically move the verts on the plane to make it vertical, this means we are dealing with the same orientation regardless of type
				SwapZY(playerObjectRightEye);
			}

			// We don't need the collider - if people need these to be collidable they can place a physics Atom (or comment out these 3 lines)
			Collider col = playerObject.GetComponent<Collider>();
			if (col)
				Destroy(col);
			col = playerObjectRightEye.GetComponent<Collider>();
			if (col)
				Destroy(col);

			renderer = playerObject.GetComponent<Renderer>();
			if (!renderer)
			{
				SuperController.LogMessage("No renderer found L");
				return;
			}
			rendererRightEye = playerObjectRightEye.GetComponent<Renderer>();
			if (!rendererRightEye)
			{
				SuperController.LogMessage("No renderer found R");
				return;
			}

			Shader shader = Shader.Find("UI/Default");
			if (shader != null)
			{
				renderer.material = new Material(shader);
				rendererRightEye.material = new Material(shader);
			}

			originalLayer = playerObject.layer;
			originalMask = CameraTarget.centerTarget.targetCamera.cullingMask;
			playerObjectRightEye.layer = 17;
			rendererRightEye.enabled = false;
			//renderer.enabled = false;

		
			playerVideo = playerObject.AddComponent<VideoPlayer>();
			player = DummyVideoObject.AddComponent<VideoPlayer>();

			playerVideo.playOnAwake = false;
            player.playOnAwake = false;

 			playerVideo.audioOutputMode = VideoAudioOutputMode.AudioSource;
			player.audioOutputMode = VideoAudioOutputMode.APIOnly;

			playerVideo.renderMode = VideoRenderMode.APIOnly;

			playerVideo.aspectRatio = VideoAspectRatio.NoScaling;
			player.aspectRatio = VideoAspectRatio.NoScaling;
			playerVideo.isLooping = false;
			player.isLooping = false;
			playerVideo.loopPointReached += EndReached;
			player.prepareCompleted += PostPrepareCallback;
			
			if (jsonVideoFile.val != "")
			{
			playerVideo.url = jsonVideoFile.val;
			player.url = jsonVideoFile.val;

			player.Prepare();
            SuperController.LogMessage("Prepare");
			}
		}


		void ShiftMovieTitle()
		{
			if  (jsonVideoFile.val != "" && jsonVideoFile.val != "Please open a file")
			{	
				int displaylenght = 27;
				string mystring = jsonVideoFile.val.Substring(jsonVideoFile.val.LastIndexOf("/") + 1);
				string TextFileString = mystring;
				if (TextFileString.Length > displaylenght)
				{	
					for (int i=0 ; i < displaylenght ; i++)
						TextFileString = " " + TextFileString;
					TextFileString = TextFileString + "    "; 

					if ((TextFileString.Length - TextFileshiftindex) >= displaylenght)
					{
						TextFileString = TextFileString.Substring(TextFileshiftindex, displaylenght);
					}
					else
					{
						TextFileString = TextFileString.Substring(TextFileshiftindex) + TextFileString.Substring(displaylenght, displaylenght - TextFileString.Substring(TextFileshiftindex).Length);
					}	

					TextFileshiftindex++;
					//if (TextFileshiftindex == displaylenght)
					if (TextFileshiftindex == (((mystring) + "    ").Length) + displaylenght)
						TextFileshiftindex = displaylenght;
				}
				//SuperController.LogMessage(TextFileString);
				TextFileTransform.gameObject.GetComponent<UnityEngine.UI.Text>().text = TextFileString; 
			}
		}


		void SwapZY(GameObject shape)
		{
			MeshFilter mf = shape.GetComponent<MeshFilter>();
			Mesh mesh;
			if ((!mf) || (!(mesh = mf.mesh)))
			{
				//LogError("VideoController: SwapZY, no mesh");
				return;
			}
			Vector3[] verts = mesh.vertices;
			for (int i = 0; i < verts.Length; i++)
			{
				//verts[i].x = -verts[i].x / 10.0f;
				//verts[i].y = -verts[i].z / 10.0f;
				verts[i].x = verts[i].x / 2.5f; 
				verts[i].y = -verts[i].z / 2.5f  * (9f / 16f); 
				verts[i].z = 0;
			}
			mesh.vertices = verts;
			mesh.RecalculateBounds();
		}


		void PostPrepareCallback (VideoPlayer player)
		{
			Atom myAtom;
			Transform ButtonTrasform;    

			provider = player.GetAudioSampleProvider(0);
			if (provider == null)
				{
					SuperController.LogMessage("No Audio Provider found");
					return;
				}

			channelcount = (int) provider.channelCount;
			SuperController.LogMessage(provider.channelCount.ToString("n"));

			provider.sampleFramesAvailable += SampleFramesAvailable;
			provider.enableSampleFramesAvailableEvents = true;
			provider.enableSilencePadding = true;
			provider.freeSampleFrameCountLowThreshold =  provider.maxSampleFrameCount / 4;

			myAtom = SuperController.singleton.GetAtomByUid("VirtualHomeTheater");

			channels[0] = (int) jsonChannelFLFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonFL" + (channels[0]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

			channels[1] = (int) jsonChannelFRFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonFR" + (channels[1]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

			channels[2] = (int) jsonChannelCFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonC" + (channels[2]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

			channels[3] = (int) jsonChannelLFEFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonLFE" + (channels[3]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

			channels[4] = (int) jsonChannelBSLFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonBSL" + (channels[4]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

			channels[5] = (int) jsonChannelBSRFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonBSR" + (channels[5]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

			channels[6] = (int) jsonChannelSLFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonSL" + (channels[6]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;

			channels[7] = (int) jsonChannelSRFloat.val;
			ButtonTrasform = getObjectRoot2(myAtom.reParentObject, "VirtualHomeTheater/UIButtonSR" + (channels[7]+1).ToString());
			ButtonTrasform = getObjectRoot(ButtonTrasform, "Text" );
			ButtonTrasform.gameObject.GetComponent<Text>().color = Color.red;


			switch((int)(provider.channelCount)) 
			{
				case 8:
					ToggleInterfaceTransform51.gameObject.SetActive(true);				
					ToggleInterfaceTransform71.gameObject.SetActive(true);
					for (int i=2; i<8; i++)
					SpheresTransforms[i].gameObject.SetActive(true);
					break;
				case 6:
					ToggleInterfaceTransform51.gameObject.SetActive(true);	
					ToggleInterfaceTransform71.gameObject.SetActive(false);
					for (int i=2; i<6; i++)
						SpheresTransforms[i].gameObject.SetActive(true);
					for (int i=6; i<8; i++)
						SpheresTransforms[i].gameObject.SetActive(false);
					break;
				default:
					ToggleInterfaceTransform51.gameObject.SetActive(false);				
					ToggleInterfaceTransform71.gameObject.SetActive(false);
					for (int i=2; i<8; i++)
						SpheresTransforms[i].gameObject.SetActive(false);
					break;
			}		

			float[] volumes = new float[8];

			volumes[0] = jsonVolumeFLFloat.val;
			volumes[1] = jsonVolumeFRFloat.val;	
			volumes[2] = jsonVolumeCFloat.val;	
			volumes[3] = jsonVolumeLFEFloat.val;
			volumes[4] = jsonVolumeBSLFloat.val;
			volumes[5] = jsonVolumeBSRFloat.val;		
			volumes[6] = jsonVolumeSLFloat.val;
			volumes[7] = jsonVolumeSRFloat.val;

			AudioClip dummyClip;
			float[] dummyAudio = new float[((int)provider.sampleRate * 100)];
			//float[] dummyAudio = new float[4800000];
			for (int i = 0; i < dummyAudio.Length; i += 1)
			{
				dummyAudio[i] = 1.0f; 
			}

			float dist = 4.5f;

			for (int j=0; j < (int) provider.channelCount; j++)
			{
				myAtom = SuperController.singleton.GetAtomByUid(spheres[j]);
			
				FreeControllerV3 Ccontroller = myAtom.GetStorableByID("control") as FreeControllerV3;
				if (Ccontroller == null)
				{
					SuperController.LogMessage("No Ccontroller found");
					return;
				}
				audioCObj = Ccontroller.gameObject;

				audiosources[j] = audioCObj.AddComponent<AudioSource>();
				getchannels[j] = audioCObj.AddComponent<GetChannel>();

				audiosources[j].loop = true;
				audiosources[j].spatialBlend = 1.0f;
				audiosources[j].minDistance = dist / 2.0f;
				audiosources[j].maxDistance = dist * 6.0f;
				audiosources[j].volume = volumes[j];
				audiosources[j].dopplerLevel = 0; 

				dummyClip = AudioClip.Create("", ((int)provider.sampleRate * 100), 1, (int)provider.sampleRate, false);

				dummyClip.SetData(dummyAudio, 0);
				audiosources[j].clip = dummyClip;

				audiosources[j].PlayScheduled(AudioSettings.dspTime + 0);
			}
	

			player.frame = (long) (player.frameCount * jsonTimeScrubFloat.val);

		
			if (GameObject.Find("MyRightEyeCam") != null)
			{
				rendererRightEye.enabled = false;
				CameraTarget.centerTarget.targetCamera.cullingMask = originalMask;
				CameraTarget.centerTarget.targetCamera.stereoTargetEye = StereoTargetEyeMask.Both;
				Vector2 scale = new Vector2 (1f, 1f);				
				renderer.material.mainTextureScale = scale;
				Vector2 offset = new Vector2 (0f, 0f);
				renderer.material.mainTextureOffset = offset;
				playerObject.layer = originalLayer;
				SuperController.LogMessage("Destroying Right Eye Cam");
				Destroy(GoCameraRight);
			}

			if ((jsonVideo3DSBS.val || jsonVideo3DOU.val) && (SuperController.singleton.isOVR || SuperController.singleton.isOpenVR))
			{
					GameObject CEye = CameraTarget.centerTarget.targetCamera.gameObject;
					GoCameraRight = new GameObject();
					GoCameraRight.name = "MyRightEyeCam";
					Camera CameraRight = GoCameraRight.AddComponent<Camera>();
					if (CameraRight == null)
						SuperController.LogMessage("No camera added");
					CameraRight.CopyFrom(CameraTarget.centerTarget.targetCamera);
					GoCameraRight.transform.SetParent(CEye.transform.parent.transform);
					CameraTarget.centerTarget.targetCamera.stereoTargetEye = StereoTargetEyeMask.Left;
					CameraRight.stereoTargetEye = StereoTargetEyeMask.Right;
					int originalMask = CameraTarget.centerTarget.targetCamera.cullingMask;
					CameraTarget.centerTarget.targetCamera.cullingMask = originalMask - (1<<17);
					CameraRight.cullingMask = originalMask - (1<<16);
					Vector2 scale;
					Vector2 offset;
					if (jsonVideo3DSBS.val)
					{
						scale = new Vector2 (0.5f, 1f);
						offset = new Vector2 (0.5f, 0f);	
					}
					else
					{
						scale = new Vector2 (1f, 0.5f);
						offset = new Vector2 (0f, 0.5f);	
					}
									
					renderer.material.mainTextureScale = scale;
					rendererRightEye.material.mainTextureScale = scale;
					renderer.material.mainTextureOffset = offset;
					playerObject.layer = 16;
					rendererRightEye.enabled = true;
			}


			playerVideo.Prepare();


			double myinterval = (double) (((((((double)provider.maxSampleFrameCount / (double) 4) * (double) 3) / (double) provider.sampleRate)) - (double) (jsonAudioOffsetFloat.val)) * (double) 1000);	// 3/4 of audio buffer + offset in milliseconds	
			if (myinterval <= (double) 0)
				myinterval = (double) 1;
			timer.Interval = myinterval; 
			//SuperController.LogMessage("interval " + myinterval.ToString("0.000000"));
			timer.Elapsed += new ElapsedEventHandler(VideoPostponePlay);
			timer.Start();		

			player.Play();
		}


		void VideoPostponePlay(object sender, ElapsedEventArgs e)
		{
			playerVideo.frame = (long) (player.frameCount * jsonTimeScrubFloat.val);
			playerVideo.Play();
			if (jsonVideoPaused.val == true)
			{	
				timer2.Interval =  (double) (15 / playerVideo.frameRate * 1000); //let's show some first videoframes on scene resume before pause
				timer2.Elapsed += new ElapsedEventHandler(PauseVideo);
				timer2.Start();
			}	
			timer.Stop();
		}


		void PauseVideo(object sender, ElapsedEventArgs e)
		{
				playerVideo.Pause();
				player.Pause();
				for (int i=0; i<8; i++)
				{
					if (audiosources[i] != null)
						audiosources[i].Stop();
				}	
				timer2.Stop();
		}			


		void SampleFramesAvailable(AudioSampleProvider provider, uint sampleFrameCount)
		{
			using (NativeArray<float> buffer = new NativeArray<float>(
						(int)sampleFrameCount * provider.channelCount, Allocator.Temp))
			{
				var sfCount = provider.ConsumeSampleFrames(buffer);

				for (int i = 0; i < sfCount; i += 1)
				{
					for (int j=0; j < (int) provider.channelCount; j++)
						{
							getchannels[j].audiodataQueue.Enqueue(buffer[(i*provider.channelCount)+channels[j]]);
							getchannels[j].audiodataQueue.Enqueue(buffer[(i*provider.channelCount)+channels[j]]);			
						}	
				}
			}
		}


		void EndReached(VideoPlayer vp)
		{
			StopCallback();
		}



		// Utils

		private Transform getObjectRoot( Transform parent, string nametosearch ) 
		{
			foreach( Transform child in parent )
			{
				if (child.name == nametosearch)
				{
					return child;
				} 
				else
				{
					Transform childSearch = getObjectRoot(child, nametosearch);
					if (childSearch != null) return childSearch;
				}
			}

			return null;
		}

		private Transform getObjectRoot2( Transform parent, string nametosearch ) 
		{
			foreach( Transform child in parent )
			{	
				ForceReceiver forcerec = child.gameObject.GetComponent<ForceReceiver>();

				if ((child.name == "object") && (forcerec != null) && (forcerec.containingAtom.name == nametosearch))
				{
					return child;
				} 
				else
				{
					Transform childSearch = getObjectRoot2(child, nametosearch);
					if (childSearch != null) return childSearch;
				}
			}
			return null;
		}


		void ResetPlayer()
		{	
			for (int i=0; i<8 ; i++)
			{
				if (audiosources[i] != null)
				{		
					Destroy(audiosources[i].clip);
					Destroy(audiosources[i]);
				}		
				if (getchannels[i] != null)
					Destroy(getchannels[i]);
			}		
				player.Prepare();
				SuperController.LogMessage("Prepare");
		}

}

}